#include "lvgl_watch_task.h"
#include <stdio.h>
#include "lvgl.h"

LV_IMG_DECLARE(img_cogwheel_argb);
LV_IMG_DECLARE(second1);
LV_IMG_DECLARE(min1);
LV_IMG_DECLARE(hour1);
LV_IMG_DECLARE(hour2);
LV_IMG_DECLARE(min2);
LV_IMG_DECLARE(second2);
LV_IMG_DECLARE(shoubiao1);
LV_IMG_DECLARE(watch_a1);
LV_IMG_DECLARE(watch_a2);
LV_IMG_DECLARE(watch_a4);
void task_watch_switch(lv_task_t * task);
u16 watch_cnt=0;
lv_obj_t * img_watch_a1;
lv_obj_t * img_watch_a2;
lv_obj_t * img_watch_a4;
lv_obj_t * img_shoubiao;
extern lv_obj_t *roller1 ;

u8 roller_task_cnt=0;
lv_obj_t *roller1 ;
LV_FONT_DECLARE(lv_font_montserrat_18);
void task_roller1(lv_task_t * task)
{
  roller_task_cnt++;
  lv_roller_set_selected(roller1,roller_task_cnt%7,LV_ANIM_ON);
}
    
//static void event_handler(lv_obj_t * obj, lv_event_t event)
//{
//    if(event == LV_EVENT_VALUE_CHANGED) {
//        char buf[32];
//        lv_roller_get_selected_str(obj, buf, sizeof(buf));
//        printf("Selected month: %s\n", buf);
//    }
//}

void lv_ex_roller_1(void)
{
  
  
    static lv_style_t style_bg,style_sel;
    lv_style_init(&style_bg);

    /*Set a background color and a radius*/
    lv_style_set_radius(&style_bg, LV_STATE_DEFAULT, 6);
    lv_style_set_bg_opa(&style_bg, LV_STATE_DEFAULT, LV_OPA_COVER);
    lv_style_set_bg_color(&style_bg, LV_STATE_DEFAULT, LV_COLOR_WHITE);
    lv_style_set_border_width(&style_bg, LV_STATE_DEFAULT, 1);
    lv_style_set_border_color(&style_bg, LV_STATE_DEFAULT, LV_COLOR_MAKE(174, 179, 183));   
    lv_style_set_bg_grad_color(&style_bg, LV_STATE_DEFAULT, LV_COLOR_BLACK); 
    lv_style_set_outline_color(&style_bg, LV_STATE_DEFAULT, LV_COLOR_BLACK);   
    lv_style_set_shadow_color(&style_bg, LV_STATE_DEFAULT, LV_COLOR_BLACK);  
    lv_style_set_value_color(&style_bg, LV_STATE_DEFAULT, LV_COLOR_BLACK);  
    lv_style_set_text_sel_color(&style_bg, LV_STATE_DEFAULT, LV_COLOR_BLACK); 
    lv_style_set_line_color(&style_bg, LV_STATE_DEFAULT, LV_COLOR_BLACK);   

  
  
    lv_style_set_radius(&style_bg, LV_STATE_FOCUSED, 6);
    lv_style_set_bg_opa(&style_bg, LV_STATE_FOCUSED, LV_OPA_COVER);
    lv_style_set_bg_color(&style_bg, LV_STATE_FOCUSED, LV_COLOR_WHITE);
    lv_style_set_border_width(&style_bg, LV_STATE_FOCUSED, 1);
    lv_style_set_border_color(&style_bg, LV_STATE_FOCUSED, LV_COLOR_MAKE(174, 179, 183));   
    lv_style_set_bg_grad_color(&style_bg, LV_STATE_FOCUSED, LV_COLOR_BLACK); 
    lv_style_set_outline_color(&style_bg, LV_STATE_FOCUSED, LV_COLOR_BLACK);   
    lv_style_set_shadow_color(&style_bg, LV_STATE_FOCUSED, LV_COLOR_BLACK);  
    lv_style_set_value_color(&style_bg, LV_STATE_FOCUSED, LV_COLOR_BLACK);  
    lv_style_set_text_sel_color(&style_bg, LV_STATE_FOCUSED, LV_COLOR_BLACK); 
    lv_style_set_line_color(&style_bg, LV_STATE_FOCUSED, LV_COLOR_BLACK);   
  
    
    lv_style_set_pad_left(&style_bg, LV_STATE_DEFAULT, 1);
    lv_style_set_pad_right(&style_bg, LV_STATE_DEFAULT, 1);  

    lv_style_set_text_font(&style_bg, LV_STATE_DEFAULT, &lv_font_montserrat_18);
    lv_style_set_text_color(&style_bg, LV_STATE_DEFAULT, LV_COLOR_RED);  //ɫ

    lv_style_copy(&style_sel, &style_bg);
    lv_style_set_bg_color(&style_bg, LV_STATE_DEFAULT, LV_COLOR_BLACK);
  
    roller1 = lv_roller_create(lv_scr_act(), NULL);
    lv_roller_set_options(roller1,
                        "MON 10\n"//mon
                        "TUE 11\n"
                        "WEN 12\n"
                        "THU 13\n"
                        "FRI 14\n"
                        "SAT 15\n"
                        "SUN 16\n"
                        ,LV_ROLLER_MODE_INIFINITE);

    lv_roller_set_visible_row_count(roller1, 1);
//    lv_obj_align(roller1, NULL, LV_ALIGN_CENTER, 68, 0);
    lv_obj_align(roller1, NULL, LV_ALIGN_CENTER, 55, -15+6);    
    lv_obj_set_size(roller1, 35, 20);  
    

        
    lv_obj_add_style(roller1, LV_ROLLER_PART_BG, &style_bg);
    lv_obj_add_style(roller1, LV_ROLLER_PART_SELECTED, &style_sel);
    lv_obj_add_style(roller1, _LV_ROLLER_PART_VIRTUAL_LAST, &style_sel);
    
    lv_task_t * task = lv_task_create(task_roller1, 5000, LV_TASK_PRIO_HIGHEST, &roller_task_cnt); 
}
void lvgl_watch_task(void)
{
  
    //ʾֱ
    /* Now create the actual image */
    img_shoubiao = lv_img_create(lv_scr_act(), NULL);
    lv_img_set_src(img_shoubiao, &shoubiao1);
    lv_obj_align(img_shoubiao, NULL, LV_ALIGN_CENTER, 0, 0);
//    lv_obj_set_hidden(img_shoubiao, true);//һֱʽ
  
    img_watch_a1 = lv_img_create(lv_scr_act(), NULL);
    lv_img_set_src(img_watch_a1, &watch_a1);
    lv_obj_align(img_watch_a1, NULL, LV_ALIGN_CENTER, 4, -4);
    lv_obj_set_hidden(img_watch_a1, true);

    img_watch_a2 = lv_img_create(lv_scr_act(), NULL);
    lv_img_set_src(img_watch_a2, &watch_a2);
    lv_obj_align(img_watch_a2, NULL, LV_ALIGN_CENTER, 6, 18);
    lv_obj_set_hidden(img_watch_a2, true);

    img_watch_a4 = lv_img_create(lv_scr_act(), NULL);
    lv_img_set_src(img_watch_a4, &watch_a4);
    lv_obj_align(img_watch_a4, NULL, LV_ALIGN_CENTER, 10, -10);
    lv_obj_set_hidden(img_watch_a4, true);


    lv_task_t * task = lv_task_create(task_watch_switch, 10000, LV_TASK_PRIO_MID, &watch_cnt);   


    lv_ex_roller_1();//ؼ
//    //ʱ붯
    lv_obj_t * img_hour = lv_img_create(lv_scr_act(), NULL);
    lv_img_set_src(img_hour, &hour2);
    lv_obj_align(img_hour, NULL, LV_ALIGN_CENTER, -5, 13);
    lv_img_set_pivot(img_hour, 14, 12);    /*Rotate around the top left corner*/

    lv_anim_t a_hour;
    lv_anim_init(&a_hour);
    lv_anim_set_var(&a_hour, img_hour);
    lv_anim_set_exec_cb(&a_hour, (lv_anim_exec_xcb_t)lv_img_set_angle);
    lv_anim_set_values(&a_hour, 0, 3600);
    lv_anim_set_time(&a_hour, 5000*100);//5000*100
    lv_anim_set_repeat_count(&a_hour, LV_ANIM_REPEAT_INFINITE);
    lv_anim_start(&a_hour);  
//     

//  
    //붯
    lv_obj_t * img_min = lv_img_create(lv_scr_act(), NULL);
    lv_img_set_src(img_min, &min2);
    lv_obj_align(img_min, NULL, LV_ALIGN_CENTER, -7, 31);
    lv_img_set_pivot(img_min, 13, 14);    /*Rotate around the top left corner*/

    lv_anim_t a_min;
    lv_anim_init(&a_min);
    lv_anim_set_var(&a_min, img_min);
    lv_anim_set_exec_cb(&a_min, (lv_anim_exec_xcb_t)lv_img_set_angle);
    lv_anim_set_values(&a_min, 0, 3600);
    lv_anim_set_time(&a_min, 5000*50);//5000*50
    lv_anim_set_repeat_count(&a_min, LV_ANIM_REPEAT_INFINITE);
    lv_anim_start(&a_min);  
  
    //붯
    /* Now create the actual image */
    lv_obj_t * img = lv_img_create(lv_scr_act(), NULL);
    lv_img_set_src(img, &second2);
    lv_obj_align(img, NULL, LV_ALIGN_CENTER, -8, 23);
    lv_img_set_pivot(img, 20, 48);    /*Rotate around the top left corner*/

    lv_anim_t a;
    lv_anim_init(&a);
    lv_anim_set_var(&a, img);
    lv_anim_set_exec_cb(&a, (lv_anim_exec_xcb_t)lv_img_set_angle);
    lv_anim_set_values(&a, 0, 3600);
    lv_anim_set_time(&a, 5000*14);//5000*14
    lv_anim_set_repeat_count(&a, LV_ANIM_REPEAT_INFINITE);
    lv_anim_start(&a);  


}


void task_watch_switch(lv_task_t * task)
{
  watch_cnt++;      

  if(watch_cnt==1)
  { 
    lv_obj_align(roller1, NULL, LV_ALIGN_CENTER, 72, -12);//ͬʽֱӦλ
    lv_obj_set_hidden(img_shoubiao, true);  
    lv_obj_set_hidden(img_watch_a1, false);     
  }
  else if(watch_cnt %2 == 0)
  { 
    lv_obj_align(roller1, NULL, LV_ALIGN_CENTER, 68, -15);
    lv_obj_set_hidden(img_watch_a1, true);  
    lv_obj_set_hidden(img_watch_a2, false);    
  }  
  else if(watch_cnt %3 ==0)
  { 
    lv_obj_align(roller1, NULL, LV_ALIGN_CENTER, 68, -16);    
    lv_obj_set_hidden(img_watch_a2, true);  
    lv_obj_set_hidden(img_watch_a4, false);    
  }  
  else if(watch_cnt %4 ==0)
  { 
    lv_obj_align(roller1, NULL, LV_ALIGN_CENTER, 55, -15);    
    lv_obj_set_hidden(img_watch_a4, true);  
    lv_obj_set_hidden(img_shoubiao, false);    
  }    
  else watch_cnt=0; 
}

